[#ftl]
[#compress]

  [#assign priority          = 100]
  [#assign timeslice         = 2]
  [#assign tasks             = 2]
  [#assign extendedtasks     = 0]
  [#assign extendedtaskinst  = 1]

  [#assign period            = 100]
  [#assign timers            = 0]
  [#assign extendedtimers    = 0]
  [#assign extendedtimerinst = 1]

  [#assign events            = 0]

  [#assign mailboxes         = 0]
  [#assign mailboxmsgnum     = 10]
  [#assign mailboxmsgsize    = 20]

  [#assign mutexes           = 0]

  [#assign semaphores        = 0]
  [#assign semavalue         = 0]

  [#assign queues            = 0]

  [#assign mempools          = 0]
  [#assign mempoolblocknum   = 10]
  [#assign mempoolblocksize  = 20]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_TASK_PRIORITY"]
          [#assign priority          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_TASK_TIME_SLICE"]
          [#assign timeslice         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TASKS"]
          [#assign tasks             = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TASKS"]
          [#assign extendedtaskinst  = definition.value?number]
        [/#if]
        [#if definition.name == "OS_TIMER_PERIOD"]
          [#assign period            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TIMERS"]
          [#assign timers            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TIMERS"]
          [#assign extendedtimerinst = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EVENTS"]
          [#assign events            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MAILBOXES"]
          [#assign mailboxes         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_NUM_MESSAGES"]
          [#assign mailboxmsgnum     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_SIZE_MESSAGE"]
          [#assign mailboxmsgsize    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MUTEXES"]
          [#assign mutexes           = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_SEMAS"]
          [#assign semaphores        = definition.value?number]
        [/#if]
        [#if definition.name == "OS_SEMA_INITIAL_VALUE"]
          [#assign semavalue         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_QUEUES"]
          [#assign queues            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MEMPOOLS"]
          [#assign mempools          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_NUM_BLOCKS"]
          [#assign mempoolblocknum   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_SIZE_BLOCK"]
          [#assign mempoolblocksize  = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index = 0]

  [#if tasks == 0]
  [#else]
    [#list 1..tasks as i]
      #n
      #t/* USER CODE BEGIN Creation_Task${index} */
      #tOS_TASK_Create(&TaskCB${index}, "Task${index}", ${priority}, Task${index}, Stack${index}, sizeof(Stack${index}), ${timeslice});#t// Create Task${index}
      #t/* USER CODE END Creation_Task${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtasks == 0]
  [#else]
    [#list 1..extendedtasks as i]
      [#if extendedtaskinst == 0]
      [#else]
        [#list 1..extendedtaskinst as j]
          #n
          #t/* USER CODE BEGIN Creation_TaskEx${index}_Inst${index2} */
          #tOS_TASK_CreateEx(&TaskCBEx${index}_Inst${index2}, "TaskEx${index}_Inst${index2}", ${priority}, TaskEx${index}, StackEx${index}_Inst${index2}, sizeof(StackEx${index}_Inst${index2}), ${timeslice}, (void*)${index2});#t// Create TaskEx${index}_Inst${index2}
          #t/* USER CODE END Creation_TaskEx${index}_Inst${index2} */
          [#assign index2 = index2 + 1]
        [/#list]
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if timers == 0]
  [#else]
    [#list 1..timers as i]
      #n
      #t/* USER CODE BEGIN Creation_Timer${index} */
      #tOS_TIMER_Create(&TimerCB${index}, Timer${index}, ${period});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Create Timer${index}
      #tOS_TIMER_Start(&TimerCB${index});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Start Timer${index}
      #t/* USER CODE END Creation_Timer${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtimers == 0]
  [#else]
    [#list 1..extendedtimers as i]
      [#if extendedtimerinst  == 0]
      [#else]
        [#list 1..extendedtimerinst as j]
          #n
          #t/* USER CODE BEGIN Creation_TimerEx${index}_Inst${index2} */
          #tOS_TIMER_CreateEx(&TimerCBEx${index}_Inst${index2}, TimerEx${index}, ${period}, (void*)${index2});#t#t#t#t#t#t // Create TimerEx${index}_Inst${index2}
          #tOS_TIMER_StartEx(&TimerCBEx${index}_Inst${index2});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Start TimerEx${index}_Inst${index2}
          #t/* USER CODE END Creation_TimerEx${index}_Inst${index2} */
          [#assign index2 = index2 + 1]
        [/#list]
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if events == 0]
  [#else]
    [#list 1..events as i]
      #n
      #t/* USER CODE BEGIN Creation_EventObject${index} */
      #tOS_EVENT_Create(&EventObjectCB${index});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Create EventObject${index}
      #t/* USER CODE END Creation_EventObject${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mailboxes == 0]
  [#else]
    [#list 1..mailboxes as i]
      #n
      #t/* USER CODE BEGIN Creation_Mailbox${index} */
      #tOS_MAILBOX_Create(&MailboxCB${index}, ${mailboxmsgnum}, ${mailboxmsgsize}, &MailboxBuffer${index});#t#t#t#t#t#t#t#t#t // Create Mailbox${index}
      #t/* USER CODE END Creation_Mailbox${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mutexes == 0]
  [#else]
    [#list 1..mutexes as i]
      #n
      #t/* USER CODE BEGIN Creation_Mutex${index} */
      #tOS_MUTEX_Create(&MutexCB${index});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Create Mutex${index}
      #t/* USER CODE END Creation_Mutex${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if semaphores == 0]
  [#else]
    [#list 1..semaphores as i]
      #n
      #t/* USER CODE BEGIN Creation_Semaphore${index} */
      #tOS_SEMAPHORE_Create(&SemaphoreCB${index}, ${semavalue});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Create Semaphore${index}
      #t/* USER CODE END Creation_Semaphore${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if queues == 0]
  [#else]
    [#list 1..queues as i]
      #n
      #t/* USER CODE BEGIN Creation_Queue${index} */
      #tOS_QUEUE_Create(&QueueCB${index}, &QueueBuffer${index}, sizeof(&QueueBuffer${index}));#t#t#t#t#t// Create Queue${index}
      #t/* USER CODE END Creation_Queue${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mempools == 0]
  [#else]
    [#list 1..mempools as i]
      #n
      #t/* USER CODE BEGIN Creation_MemPool${index} */
      #tOS_MEMPOOL_Create(&MemPoolCB${index}, MemPoolMem${index}, ${mempoolblocknum}, ${mempoolblocksize});#t#t#t#t#t#t#t#t#t#t#t // Create MemPool${index}
      #t/* USER CODE END Creation_MemPool${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

[/#compress]