[#ftl]
[#compress]

  [#assign extendedtasks     = 2]
  [#assign extendedtaskinst  = 1]

  [#assign period            = 100]
  [#assign extendedtimers    = 2]
  [#assign extendedtimerinst = 1]

  [#assign mailboxes         = 0]
  [#assign mailboxmsgnum     = 10]
  [#assign mailboxmsgsize    = 20]

  [#assign mutexes           = 0]

  [#assign semaphores        = 0]
  [#assign semavalue         = 0]

  [#assign queues            = 0]

  [#assign mempools          = 0]
  [#assign mempoolblocknum   = 10]
  [#assign mempoolblocksize  = 20]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TASKS"]
          [#assign extendedtaskinst  = definition.value?number]
        [/#if]
        [#if definition.name == "OS_TIMER_PERIOD"]
          [#assign period            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_INSTANCES_OF_EXTENDED_TIMERS"]
          [#assign extendedtimerinst = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MAILBOXES"]
          [#assign mailboxes         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_NUM_MESSAGES"]
          [#assign mailboxmsgnum     = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MAILBOX_SIZE_MESSAGE"]
          [#assign mailboxmsgsize    = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MUTEXES"]
          [#assign mutexes           = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_SEMAS"]
          [#assign semaphores        = definition.value?number]
        [/#if]
        [#if definition.name == "OS_SEMA_INITIAL_VALUE"]
          [#assign semavalue         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_QUEUES"]
          [#assign queues            = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_MEMPOOLS"]
          [#assign mempools          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_NUM_BLOCKS"]
          [#assign mempoolblocknum   = definition.value?number]
        [/#if]
        [#if definition.name == "OS_MEMPOOL_SIZE_BLOCK"]
          [#assign mempoolblocksize  = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtasks == 0]
  [#else]
    [#list 1..extendedtasks as i]
      [#if extendedtaskinst == 0]
      [#else]
        [#list 1..extendedtaskinst as j]
          #n
          #t/* USER CODE BEGIN Creation_TaskEx${index}_Inst${index2} */
          #tTaskEx${index}_Inst${index2} = osThreadCreate(osThread(TaskEx${index}), (void*)${index2});#t#t#t#t#t#t#t#t#t // Create TaskEx${index}_Inst${index2}
          #t/* USER CODE END Creation_TaskEx${index}_Inst${index2} */
          [#assign index2 = index2 + 1]
        [/#list]
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index  = 0]
  [#assign index2 = 0]

  [#if extendedtimers == 0]
  [#else]
    [#list 1..extendedtimers as i]
      [#if extendedtimerinst  == 0]
      [#else]
        [#list 1..extendedtimerinst as j]
          #n
          #t/* USER CODE BEGIN Creation_TimerEx${index}_Inst${index2} */
          #tTimerEx${index}_Inst${index2} = osTimerCreate(osTimer(TimerEx${index}), osTimerPeriodic, (void*)${index2});#t// Create TimerEx${index}_Inst${index2}
          #tif (TimerEx${index}_Inst${index2} != NULL) {
          #t#tosTimerStart(TimerEx${index}_Inst${index2}, ${period});#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Start TimerEx${index}_Inst${index2}
          #t}
          #t/* USER CODE END Creation_TimerEx${index}_Inst${index2} */
          [#assign index2 = index2 + 1]
        [/#list]
      [/#if]
      [#assign index = index + 1]
      [#assign index2 = 0]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mailboxes == 0]
  [#else]
    [#list 1..mailboxes as i]
      #n
      #t/* USER CODE BEGIN Creation_Mailbox${index} */
      #tMailbox${index} = osMessageCreate(osMessageQ(Mailbox${index}), NULL);#t#t#t#t#t#t#t#t#t#t#t#t// Create Mailbox${index}
      #t/* USER CODE END Creation_Mailbox${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mutexes == 0]
  [#else]
    [#list 1..mutexes as i]
      #n
      #t/* USER CODE BEGIN Creation_Mutex${index} */
      #tMutex${index} = osMutexCreate(osMutex(Mutex${index}));#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Create Mutex${index}
      #t/* USER CODE END Creation_Mutex${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if semaphores == 0]
  [#else]
    [#list 1..semaphores as i]
      #n
      #t/* USER CODE BEGIN Creation_Semaphore${index} */
      #tSemaphore${index} = osSemaphoreCreate(osSemaphore(Semaphore${index}), ${semavalue});#t#t#t#t#t#t#t#t#t#t// Create Semaphore${index}
      #t/* USER CODE END Creation_Semaphore${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if queues == 0]
  [#else]
    [#list 1..queues as i]
      #n
      #t/* USER CODE BEGIN Creation_Queue${index} */
      #tQueue${index} = osMailCreate(osMailQ(Queue${index}), NULL);#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t// Create Queue${index}
      #t/* USER CODE END Creation_Queue${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if mempools == 0]
  [#else]
    [#list 1..mempools as i]
      #n
      #t/* USER CODE BEGIN Creation_MemPool${index} */
      #tMemPool${index} = osPoolCreate(osPool(MemPool${index}));#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t#t // Create MemPool${index}
      #t/* USER CODE END Creation_MemPool${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

[/#compress]