[#ftl]
[#compress]

  [#assign tasks          = 2]
  [#assign extendedtasks  = 0]
  [#assign timers         = 0]
  [#assign extendedtimers = 0]

  [#list SWIPdatas as SWIP]
    [#if SWIP.defines??]
      [#list SWIP.defines as definition]
        [#if definition.name == "OS_NUMBER_OF_TASKS"]
          [#assign tasks          = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TASKS"]
          [#assign extendedtasks  = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_TIMERS"]
          [#assign timers         = definition.value?number]
        [/#if]
        [#if definition.name == "OS_NUMBER_OF_EXTENDED_TIMERS"]
          [#assign extendedtimers = definition.value?number]
        [/#if]
      [/#list]
    [/#if]
  [/#list]

  [#assign index = 0]

  [#if tasks==0]
  [#else]
    [#list 1..tasks as i]
      #n
      /* USER CODE BEGIN Prototype_Task${index} */
      static void Task${index}(void);
      /* USER CODE END Prototype_Task${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if extendedtasks==0]
  [#else]
    [#list 1..extendedtasks as i]
      #n
      /* USER CODE BEGIN Prototype_TaskEx${index} */
      static void TaskEx${index}(void* pContext);
      /* USER CODE END Prototype_TaskEx${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if timers==0]
  [#else]
    [#list 1..timers as i]
      #n
      /* USER CODE BEGIN Prototype_Timer${index} */
      static void Timer${index}(void);
      /* USER CODE END Prototype_Timer${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]

  [#assign index = 0]

  [#if extendedtimers==0]
  [#else]
    [#list 1..extendedtimers as i]
      #n
      /* USER CODE BEGIN Prototype_TimerEx${index} */
      static void TimerEx${index}(void* pData);
      /* USER CODE END Prototype_TimerEx${index} */
      [#assign index = index + 1]
    [/#list]
  [/#if]
  #n

[/#compress]